diff --git a/src/w32term.c b/src/w32term.c
index 7c2d86b..b079135 100644
--- a/src/w32term.c
+++ b/src/w32term.c
@@ -705,10 +705,12 @@ x_update_window_end (struct window *w, bool cursor_on_p,
     {
       block_input ();
 
-      if (cursor_on_p)
-	display_and_set_cursor (w, true,
-				w->output_cursor.hpos, w->output_cursor.vpos,
-				w->output_cursor.x, w->output_cursor.y);
+/* *************************************************************************** */
+/* multiple cursors */
+
+      mc_portal (w, cursor_on_p);
+
+/* *************************************************************************** */
 
       if (draw_window_fringes (w, true))
 	{
@@ -973,7 +975,11 @@ static void w32_draw_box_rect (struct glyph_string *, int, int, int, int,
 static void
 x_set_cursor_gc (struct glyph_string *s)
 {
-  if (s->font == FRAME_FONT (s->f)
+/* *************************************************************************** */
+/* multiple cursors */
+
+  struct window *w = decode_live_window (selected_window);
+  if ((s->font == FRAME_FONT (s->f)
       && s->face->background == FRAME_BACKGROUND_PIXEL (s->f)
       && s->face->foreground == FRAME_FOREGROUND_PIXEL (s->f)
       /* Sometimes we are not called for each change in the default
@@ -981,6 +987,9 @@ x_set_cursor_gc (struct glyph_string *s)
 	 test in the next line gives us a chance to resync.  */
       && s->f->output_data.w32->cursor_gc->foreground == s->face->background
       && !s->cmp)
+      || w->mc.cursor_gc_default)
+
+/* *************************************************************************** */
     s->gc = s->f->output_data.w32->cursor_gc;
   else
     {
@@ -5746,7 +5755,13 @@ x_draw_bar_cursor (struct window *w, struct glyph_row *row,
 	 invisible.  Use the glyph's foreground color instead in this
 	 case, on the assumption that the glyph's colors are chosen so
 	 that the glyph is legible.  */
-      if (face->background == cursor_color)
+/* *************************************************************************** */
+/* multiple cursors */
+
+      if (face->background == cursor_color
+          && !w->mc.cursor_gc_invisible_okay)
+
+/* *************************************************************************** */
 	cursor_color = face->foreground;
 
       x = WINDOW_TEXT_TO_FRAME_PIXEL_X (w, w->phys_cursor.x);
@@ -5823,7 +5838,13 @@ w32_clear_frame_area (struct frame *f, int x, int y, int width, int height)
 static void
 w32_draw_window_cursor (struct window *w, struct glyph_row *glyph_row,
 			int x, int y, enum text_cursor_kinds cursor_type,
-			int cursor_width, bool on_p, bool active_p)
+/* *************************************************************************** */
+/* multiple cursors */
+
+  int cursor_width, bool on_p, bool active_p,
+  Lisp_Object color_vector, Lisp_Object flavor)
+
+/* *************************************************************************** */
 {
   if (on_p)
     {
@@ -5888,31 +5909,118 @@ w32_draw_window_cursor (struct window *w, struct glyph_row *glyph_row,
 	  return;
 	}
 
-      switch (cursor_type)
-	{
-	case HOLLOW_BOX_CURSOR:
-	  x_draw_hollow_cursor (w, glyph_row);
-	  break;
-
-	case FILLED_BOX_CURSOR:
-	  draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
-	  break;
-
-	case BAR_CURSOR:
-	  x_draw_bar_cursor (w, glyph_row, cursor_width, BAR_CURSOR);
-	  break;
-
-	case HBAR_CURSOR:
-	  x_draw_bar_cursor (w, glyph_row, cursor_width, HBAR_CURSOR);
-	  break;
-
-	case NO_CURSOR:
-	  w->phys_cursor_width = 0;
-	  break;
+/* *************************************************************************** */
+/* BEGIN multiple cursors */
+  double red = XFLOAT_DATA (AREF (color_vector, 0));
+  double green = XFLOAT_DATA (AREF (color_vector, 1));
+  double blue = XFLOAT_DATA (AREF (color_vector, 2));
+  switch (cursor_type)
+  {
+    case HOLLOW_BOX_CURSOR:
+    {
+      if (red >= 0 && blue >= 0 && green >= 0)
+        /* Temporarily hijack `f->output_data.w32->cursor_pixel'.  */
+        {
+          struct frame *f = XFRAME (WINDOW_FRAME (w));
+          COLORREF orig_val = f->output_data.w32->cursor_pixel;
+          int int_red = red * 255;
+          int int_green = green * 255;
+          int int_blue = blue * 255;
+          f->output_data.w32->cursor_pixel = PALETTERGB (int_red, int_green, int_blue);
+          x_draw_hollow_cursor (w, glyph_row);
+          f->output_data.w32->cursor_pixel = orig_val;
+        }
+        else
+          x_draw_hollow_cursor (w, glyph_row);
+      break;
+    }
+    case FILLED_BOX_CURSOR:
+    {
+      if (red >= 0 && blue >= 0 && green >= 0)
+        /* Temporarily hijack `f->output_data.w32->cursor_gc' by borrowing the
+        functionality of `x_make_gc' in w32fns.c.  */
+        {
+          block_input ();
+          Lisp_Object window = (selected_window);
+          struct window *w = decode_live_window (window);
+          struct frame *f = XFRAME (WINDOW_FRAME (w));
+          int int_red = red * 255;
+          int int_green = green * 255;
+          int int_blue = blue * 255;
+          XGCValues gc_values;
+          unsigned long mask = GCFont | GCForeground | GCBackground;
+          COLORREF orig_val_a = FRAME_BACKGROUND_PIXEL (f);
+          COLORREF orig_val_b = f->output_data.w32->cursor_pixel;
+          gc_values.font = FRAME_FONT (f);
+          gc_values.foreground = FRAME_BACKGROUND_PIXEL (f);
+          gc_values.background = PALETTERGB (int_red, int_green, int_blue);
+          f->output_data.w32->cursor_gc
+            = XCreateGC (NULL, FRAME_W32_WINDOW (f), mask, &gc_values);
+          /* When `w->mc.cursor_gc_default = true', force `x_set_cursor_gc' to
+          use `s->f->output_data.w32->cursor_gc'.  */
+          w->mc.cursor_gc_default = true;
+          draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
+          w->mc.cursor_gc_default = false;
+          gc_values.font = FRAME_FONT (f);
+          gc_values.foreground = orig_val_a;
+          gc_values.background = orig_val_b;
+          f->output_data.w32->cursor_gc
+            = XCreateGC (NULL, FRAME_W32_WINDOW (f), mask, &gc_values);
+          unblock_input ();
+        }
+        else
+          draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
+      break;
+    }
+    case BAR_CURSOR:
+    {
+      if (red >= 0 && blue >= 0 && green >= 0)
+        /* Temporarily hijack `f->output_data.w32->cursor_pixel'.  */
+        {
+          struct frame *f = XFRAME (WINDOW_FRAME (w));
+          COLORREF orig_val = f->output_data.w32->cursor_pixel;
+          int int_red = red * 255;
+          int int_green = green * 255;
+          int int_blue = blue * 255;
+          f->output_data.w32->cursor_pixel = PALETTERGB (int_red, int_green, int_blue);
+          w->mc.cursor_gc_invisible_okay = true;
+          x_draw_bar_cursor (w, glyph_row, cursor_width, BAR_CURSOR);
+          w->mc.cursor_gc_invisible_okay = false;
+          f->output_data.w32->cursor_pixel = orig_val;
+        }
+        else
+          x_draw_bar_cursor (w, glyph_row, cursor_width, BAR_CURSOR);
+      break;
+    }
+    case HBAR_CURSOR:
+    {
+      if (red >= 0 && blue >= 0 && green >= 0)
+        /* Temporarily hijack `f->output_data.w32->cursor_pixel'.  */
+        {
+          struct frame *f = XFRAME (WINDOW_FRAME (w));
+          COLORREF orig_val = f->output_data.w32->cursor_pixel;
+          int int_red = red * 255;
+          int int_green = green * 255;
+          int int_blue = blue * 255;
+          f->output_data.w32->cursor_pixel = PALETTERGB (int_red, int_green, int_blue);
+          w->mc.cursor_gc_invisible_okay = true;
+          x_draw_bar_cursor (w, glyph_row, cursor_width, HBAR_CURSOR);
+          w->mc.cursor_gc_invisible_okay = false;
+          f->output_data.w32->cursor_pixel = orig_val;
+        }
+        else
+          x_draw_bar_cursor (w, glyph_row, cursor_width, HBAR_CURSOR);
+      break;
+    }
+    case NO_CURSOR:
+      w->phys_cursor_width = 0;
+      break;
+    default:
+      emacs_abort ();
+  }
+/* END multiple cursors */
+/* *************************************************************************** */
 
-	default:
-	  emacs_abort ();
-	}
     }
 }
 
diff --git a/src/window.c b/src/window.c
index 504dcd3..8daee35 100644
--- a/src/window.c
+++ b/src/window.c
@@ -6789,6 +6789,27 @@ get_phys_cursor_glyph (struct window *w)
   struct glyph *glyph;
   int hpos = w->phys_cursor.hpos;
 
+/* *************************************************************************** */
+/* multiple cursors */
+
+/* This modification enables placement of the cursor-in-fringe bitmap when
+the window-width is slightly less than `glyph_row->exact_window_width_line_p`.
+This modification also prevents drawing the real cursor on the fringe (instead
+of using the cursor-in-fringe bitmap) in the above-mentioned circumstance.
+See the following related patches:
+-  July 19, 2016:  bf5ddded70c11edaf3514b25da27fc71cfb8e965
+-  May 21, 2016:  e5015c5d9632a0bf685c093249ae4a7d3e825b13
+See the following bug reports:  #16856 and #29233. */
+
+  struct frame *f = XFRAME (w->frame);
+  int frame_char_width = FRAME_COLUMN_WIDTH (f);
+  int text_area_width = window_box_width (w, TEXT_AREA);
+  bool cursor_in_fringe_p = w->phys_cursor.x + frame_char_width >= text_area_width;
+  if (cursor_in_fringe_p)
+    return NULL;
+
+/* *************************************************************************** */
+
   if (!(w->phys_cursor.vpos >= 0
 	&& w->phys_cursor.vpos < w->current_matrix->nrows))
     return NULL;
diff --git a/src/window.h b/src/window.h
index 25c9686..482334f 100644
--- a/src/window.h
+++ b/src/window.h
@@ -76,6 +76,39 @@ one and the same, so its prev and next members are nil.
 
 A dead window has its contents field set to nil.  */
 
+/* *************************************************************************** */
+/* BEGIN multiple cursors */
+
+/* Suffixes for the `mc` window pointer prefix. */
+struct multiple_cursors
+{
+  /* Values for previous and current `window-start' and `window-end'. */
+  EMACS_INT current_start, current_end, previous_start, previous_end, current_x, previous_x;
+
+  /* True means to force `x_set_cursor_gc' to use `s->f->output_data.w32->cursor_gc'
+  in w32term.c or `s->f->output_data.x->cursor_gc' in xterm.c. */
+  bool_bf cursor_gc_default : 1;
+
+  /* True means `x_set_cursor_gc' should permit the foreground and background
+  colors to be the same.  The default behavior disallows an invisible result. */
+  bool_bf cursor_gc_invisible_okay : 1;
+
+  /* True means `mc_calc' has not run yet drawn glyph fake cursors. */
+  bool_bf draw_glyph_cursor : 1;
+
+  /* True means `mc_calc' has not run yet erased glyph fake cursors. */
+  bool_bf erase_glyph_cursor : 1;
+
+  /* True means crosshairs have not yet been drawn. */
+  bool_bf draw_crosshairs : 1;
+
+  /* True means crosshairs have not yet been erased. */
+  bool_bf erase_crosshairs : 1;
+};
+
+/* END multiple cursors */
+/* *************************************************************************** */
+
 struct cursor_pos
 {
   /* Pixel position.  These are always window relative.  */
@@ -178,6 +211,20 @@ struct window
     /* An alist with parameters.  */
     Lisp_Object window_parameters;
 
+/* *************************************************************************** */
+/* multiple cursors */
+
+    /* The cache for multiple glyph cursors.  For an example of the structure of
+    the list, see the comments at the beginning of `mc_calc' in xdisp.c.  */
+    Lisp_Object mc_glyph_cache;
+
+    /* The cache for multiple glyph/glyphless cursors that form crosshairs.  For an
+    example of the structure of the list, see the comments at the beginning of
+    `mc_crosshairs' in xdisp.c.  */
+    Lisp_Object crosshairs_cache;
+
+/* *************************************************************************** */
+
     /* No Lisp data may follow below this point without changing
        mark_object in alloc.c.  The member current_matrix must be the
        first non-Lisp member.  */
@@ -280,6 +327,14 @@ struct window
 
 #ifdef HAVE_WINDOW_SYSTEM
 
+/* *************************************************************************** */
+/* multiple cursors */
+
+    /* The prefix for window pointers relating to multiple cursors.  */
+    struct multiple_cursors mc;
+
+/* *************************************************************************** */
+
     /* Cursor type of last cursor drawn on the window.  */
     enum text_cursor_kinds phys_cursor_type;
 
@@ -417,6 +472,23 @@ XWINDOW (Lisp_Object a)
   return XUNTAG (a, Lisp_Vectorlike);
 }
 
+/* *************************************************************************** */
+/* multiple cursors */
+
+INLINE void
+wset_mc_glyph_cache (struct window *w, Lisp_Object val)
+{
+  w->mc_glyph_cache = val;
+}
+
+INLINE void
+wset_crosshairs_cache (struct window *w, Lisp_Object val)
+{
+  w->crosshairs_cache = val;
+}
+
+/* *************************************************************************** */
+
 /* Most code should use these functions to set Lisp fields in struct
    window.  */
 INLINE void
